<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: activity.php,v 1.17 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['bug']))    { $bug = $_REQUEST['bug']; }    else { $bug = NULL; }

d_StartPage(gettext("Activity Log"));
if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
d_DrawNav($_USER['uname']);

d_DrawHeader(gettext("Activity Log"));

if (!isset($bug)) 
{
    print("<p><font color=\"red\">" . gettext("The bug you selected does not exist or is invalid.") . "</font></p>");
    d_DrawFooter();
    exit();
} else {
    $result = $db->query("SELECT private FROM bugs WHERE bid = '$bug'");
    dberror($result);
    $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
    if ($result->numRows() == 0)
    {
        // empty bug; non-existant
        print("<p><font color=\"red\">" . gettext("The bug you selected does not exist or is invalid.") . "</font></p>");
        d_DrawFooter();
        exit();
    }
    if ($row['private'] == 1 && !isset($_USER['uid']))
    {
        print("<p><font color=\"red\">" . gettext("The bug you selected is marked private and is not available to unregistered users.") . "</font></p>");
        d_DrawFooter();
        exit();
    }
    $result->free();

    $string['activityby'] = gettext("Activity by");
    $string['activity']   = gettext("Activity");
    $string['oldval']     = gettext("Old value");
    $string['newval']     = gettext("New value");
    $string['date']       = gettext("Date");

    $data = <<<EOT
    <center>
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="20%">
          <b>{$string['activityby']}</b>
        </td>
        <td width="20%">
          <b>{$string['activity']}</b>
        </td>
        <td width="20%">
          <b>{$string['oldval']}</b>
        </td>
        <td width="20%">
          <b>{$string['newval']}</b>
        </td>
        <td width="20%">
          <b>{$string['date']}</b>
        </td>
      </tr>
EOT;
    $result = $db->query("SELECT * FROM bugactivity WHERE bid = '$bug' ORDER BY b_date");
    dberror($result);
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $p_email = $db->getOne("SELECT email FROM users WHERE uid = '" . $row['b_user'] . "'");
        switch($row['what'])
        {
            case 0:
                $p_status = gettext("Status Change"); break;
            case 1:
                $p_status = gettext("Reassigned"); break;
            case 2:
                $p_status = gettext("State Change"); break;
            case 3:
                $p_status = gettext("Added to CC"); break;
            case 4:
                $p_status = gettext("Removed from CC"); break;
            case 5:
                $p_status = gettext("Created Attachment"); break;
            case 6:
                $p_status = gettext("Resolution Priority Change"); break;
            case 7:
                $p_status = gettext("Severity Change"); break;
            case 8:
                $p_status = gettext("Description Change"); break;
            case 9:
                $p_status = gettext("Version Change"); break;
            case 10:
                $p_status = gettext("Component Change"); break;
        }
        $p_oldval = stripslashes($row['oldval']);
        $p_newval = stripslashes($row['newval']);
        $p_date   = d_getTime($row['b_date']);
        $data    .= <<<EOT
            <tr>
                <td width="20%" valign="top">{$p_email}</td>
                <td width="20%" valign="top">{$p_status}</td>
                <td width="20%" valign="top">{$p_oldval}</td>
                <td width="20%" valign="top">{$p_newval}</td>
                <td width="20%" valign="top">{$p_date}</td>
            </tr>
EOT;
    }
    $data .= "</table>";
    $data .= "<p><a href=\"query.php?bug=$bug\">" . sprintf(gettext("Return to bug #%s"), $bug) . "</a>.</p>";
    print($data);
}

d_DrawFooter();
?>
