<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: admin.php,v 1.36 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['go'])) { $go = $_REQUEST['go']; } else { $go = NULL; }

d_StartPage(gettext("Edit Anthill Preferences"));

if (!do_checkacs($_USER['access'])) exit;

// change user information
if ($go == "change")
{
    for($HTTP_POST_VARS; $k=key($HTTP_POST_VARS);next($HTTP_POST_VARS))
    {
        // update configuration
        if ($k == "sitename" || $k == "siteblurb" || $k == "newublurb" || $k == "prefblurb" || $k == "emailfooter")
        {
            $value = addslashes($HTTP_POST_VARS[$k]);
        } else {
            $value = $HTTP_POST_VARS[$k];
        }
        if ($k != "go")
        {
            $query  = "UPDATE config set ";
            $query .= "value = '" . $value . "' ";
            $query .= "WHERE name = '" . $k . "'";
            $result = $db->query($query);
            dberror($result);
        }
    }
    $msg      = "<span class=\"text\"><center>" . gettext("Your changes have been saved.") . "</center></span>";
}

// refresh form with new values
$result = $db->query("SELECT * FROM config");
dberror($result);
$config = array();
while ($a = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $config[$a['name']] = $a['value'];
}

d_DrawNav($_USER['uname']);

d_DrawHeader(gettext("Edit Anthill Preferences"));

if (isset($msg))
{
    print($msg);
}
print ("<p>" . gettext("Here you are able to configure some operating parameters for Anthill.") . "</p>");

$p_string['sitename']    = gettext("Site Name");
$p_string['adminemail']  = gettext("Administrator Email");
$p_string['defcc']       = gettext("Default CC");
$p_string['fbcolor']     = gettext("First Bar Color");
$p_string['sbcolor']     = gettext("Second Bar Color");
$p_string['theme']       = gettext("Theme");
$p_string['allownew']    = gettext("Allow New Users?");
$p_string['defbugstate'] = gettext("Default Bug State");
$p_string['forceview']   = gettext("Force Viewing Bug Rules");
$p_string['adminacs']    = gettext("Administrator Access Level");
$p_string['devacs']      = gettext("Developer Access Level");
$p_string['basicacs']    = gettext("Basic User Access Level");
$p_string['maxupsize']   = gettext("Maximum Attachment File Size");
$p_string['bytes']       = gettext("bytes");
$p_string['daemname']    = gettext("Mailer Daemon's Name");
$p_string['daememail']   = gettext("Mailer Daemon Email");
$p_string['daemrep']     = gettext("Mailer Daemon Reply-To");
$p_string['daemblurb']   = gettext("(This is useful if you want replies to Anthill diff messages to go to a real email address or mailing list instead of to the daemon's email address.  This is <b>only</b> used with diff messages.)");
$p_string['difffoot']    = gettext("Footer Appended to Diff Emails");
$p_string['diffblurb']   = gettext("(Use <b>&lt;br&gt;</b> to force a line break.)");
$p_string['sitetext']    = gettext("Site Text (used in index)");
$p_string['newureg']     = gettext("New User Text (used in registration)");
$p_string['preftext']    = gettext("Preferences Text (used in preferences)");
$p_string['change']      = gettext("Change");

$p_sitename  = stripslashes($config['sitename']);
$p_themelist = NULL;
$themelist   = NULL;

$handle = opendir($rtmpldir);
while ($file = readdir($handle))
{
    if ((!ereg("[.]",$file)))
    {
        $themelist .= "$file ";
    }
}
closedir($handle);
$themelist = explode(" ", $themelist);
sort($themelist);
for ($i=0; $i < sizeof($themelist); $i++)
{
    if ($themelist[$i] != "")
    {
        $foo          = strtolower($config['theme']) == strtolower($themelist[$i]) ? "selected" : "";
        $p_themelist .= sprintf("<option value=\"%s\" %s>%s</option>\n",$themelist[$i],$foo,$themelist[$i]);
    }
}

$p_newuserlist  = "<option value=\"1\"";
if ($config['newusers'] == 1)
{
    $p_newuserlist .= " SELECTED";
}
$p_newuserlist .= ">" . gettext("New Users Can Register") . "</option>\n";
$p_newuserlist .= "<option value=\"0\"";
if ($config['newusers'] == 0)
{
    $p_newuserlist .= " SELECTED";
}
$p_newuserlist .= ">" . gettext("Closed Site (No New Users)") . "</option>\n";

$p_defprivlist  = "<option value=\"1\"";
if ($config['defpriv'] == 1)
{
    $p_defprivlist .= " SELECTED";
}
$p_defprivlist .= ">" . gettext("Private") . "</option>\n";
$p_defprivlist .= "<option value=\"0\"";
if ($config['defpriv'] == 0)
{
    $p_defprivlist .= " SELECTED";
}
$p_defprivlist .= ">" . gettext("Public") . "</option>\n";

$p_showruleslist  = "<option value=\"1\"";
if ($config['showrules'] == 1)
{
    $p_showruleslist .= " SELECTED";
}
$p_showruleslist .= ">" . gettext("Yes") . "</option>\n";
$p_showruleslist .= "<option value=\"0\"";
if ($config['showrules'] == 0)
{
    $p_showruleslist .= " SELECTED";
}
$p_showruleslist .= ">" . gettext("No") . "</option>\n";

$p_emailfooter = stripslashes($config['emailfooter']);
$p_siteblurb   = stripslashes($config['siteblurb']);
$p_newublurb   = stripslashes($config['newublurb']);
$p_prefblurb   = stripslashes($config['prefblurb']);

$data = <<<EOT
    <form method="post" action="admin.php">
    <table border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#000000" width="100%">
        <tr><td><table border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#ffffff" width="100%">
            <tr><td><table border="0" cellpadding="2" cellspacing="2" width="100%">
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['sitename']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="sitename" size="50" maxlength="100" value="{$p_sitename}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['adminemail']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="adminemail" size="50" maxlength="100" value="{$config['adminemail']}"></td>
                </tr>
                <tr>
                  <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['defcc']}:</b></td>
                  <td bgcolor="#ffffff" width="50%"><input type="text" name="autocc" size="50" maxlength="100" value="{$config['autocc']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['fbcolor']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="barcol1" size="10" maxlength="20" value="{$config['barcol1']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['sbcolor']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="barcol2" size="10" maxlength="20" value="{$config['barcol2']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['theme']}:</b></td>
                    <td bgcolor="#ffffff" width="50%">
                        <select name="theme">
                        {$p_themelist}
                        </select>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['allownew']}</b></td>
                    <td bgcolor="#ffffff" width="50%">
                        <select name="newusers">
                        ${p_newuserlist}
                        </select>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['defbugstate']}:</b></td>
                    <td bgcolor="#ffffff" width="50%">
                        <select name="defpriv">
                        ${p_defprivlist}
                        </select>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['forceview']}:</b></td>
                    <td bgcolor="#ffffff" width="50%">
                        <select name="showrules">
                        {$p_showruleslist}
                        </select>
                    </td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['adminacs']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="adminac" size="3" maxlength="3" value="{$config['adminac']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['devacs']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="devac" size="3" maxlength="3" value="{$config['devac']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['basicacs']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="defaultac" size="3" maxlength="3" value="{$config['defaultac']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['maxupsize']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="maxfsize" size="9" maxlength="9" value="{$config['maxfsize']}"> {$p_string['bytes']}</td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['daemname']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="mdaemon" size="50" maxlength="100" value="{$config['mdaemon']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right"><b>{$p_string['daememail']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="memail" size="50" maxlength="100" value="{$config['memail']}"></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right" valign="top"><b>{$p_string['daemrep']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><input type="text" name="mdaemonreplyto" size="50" maxlength="100" value="{$config['mdaemonreplyto']}">
                    <br /><font size="-2">{$p_string['daemblurb']}</font></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right" valign="top"><b>{$p_string['difffoot']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><textarea name="emailfooter" cols="50" rows="2" wrap="Virtual">{$p_emailfooter}</textarea>
                    <br /><font size="-2">{$p_string['diffblurb']}</font></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right" valign="top"><b>{$p_string['sitetext']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><textarea name="siteblurb" cols="50" rows="3" wrap="Virtual">{$p_siteblurb}</textarea></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right" valign="top"><b>{$p_string['newureg']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><textarea name="newublurb" cols="50" rows="3" wrap="Virtual">{$p_newublurb}</textarea></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right" valign="top"><b>{$p_string['preftext']}:</b></td>
                    <td bgcolor="#ffffff" width="50%"><textarea name="prefblurb" cols="50" rows="3" wrap="Virtual">{$p_prefblurb}</textarea></td>
                </tr>
                <tr>
                    <td bgcolor="#ffffff" width="50%" align="right">
                        <input type="submit" value="{$p_string['change']}">
                        <input type="hidden" name="go" value="change">
                    </td>
                    <td bgcolor="#ffffff" width="50%">&nbsp;</td>
                </tr>
            </table></td>
        </tr></table></td>
    </tr></table></form>
EOT;

$data .= "<p>" . gettext("Change <a href=\"editproducts.php\">products and components</a> information.") . "</p>";
$data .= "<p>" . gettext("Edit <a href=\"editusers.php\">user</a> information and add new users.") . "</p>";

print($data);

d_DrawFooter();
?>
