<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: advancedquery.inc.php,v 1.4 2004/02/04 16:54:53 vdanen Exp $
//
// Anthill advanced query functions

function z_MakeDropDown($formField, $lookupTable, $lookupField, $lookupDisplay, $nodeleted)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;

    if ($nodeleted == 1)
    {
        $query = "SELECT $lookupField,$lookupDisplay FROM $lookupTable WHERE deleted = '0'";
    } else {
        $query = "SELECT $lookupField,$lookupDisplay FROM $lookupTable";
    }
    $zresult = $db->query($query);
    dberror($zresult);
    $result  = "<select size=1 name=\"$formField\">";
    $result .= "<option value=-1> * " . gettext("All") . " " . ucfirst($lookupTable) . "</option>";
    while ($row = $zresult->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $result .= "<option value=\"" . $row[$lookupField] . "\"> " . $row[$lookupDisplay] . "</option> "; 
    }
    $zresult->free();
    $result .= "</select>";
    return($result);
}

function z_MakeDateRangeDropDown($formField)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $today = getdate(); 
    $month = $today['month']; 
    $mday  = $today['mday']; 
    $year  = $today['year']; 

    $months = array("1"=>"January","2"=>"Febuary","3"=>"March","4"=>"April",
		    "5"=>"May","6"=>"June","7"=>"July","8"=>"August",
		    "9"=>"September","10"=>"October","11"=>"November","12"=>"December");

    $result = "<select name=\"$formField" . "_day\">";
    for ($i=1; $i<32; $i++)
    {
        $result .= "<option value=\"$i\"> $i </option>";
    }
    $result .= "</select> ";

    $result .= "<select name=\"$formField" ."_month\">";
    while (list($month, $month_name) = each($months))
    {
        $result .= "<option value=\"$month\"> $month_name </option> ";
    }
    $result .= "</select> ";

    $result .= "<select name=\"$formField" . "_year\">";
    for ($i=2001; $i<($year+1); $i++)
    {
        $result .= "<option value=\"$i\"> $i </option>";
    }
    $result .= "</select> ";
    return($result);
}


function z_MakeFieldCheckBoxes($TableName)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;

    $zresult = $db->query("SELECT * FROM $TableName LIMIT 1");
    dberror($zresult);
    for ($i=0; $i<$zresult->numRows(); $i++)
    {
        $meta = $zresult->fetchRow(DB_FETCHMODE_ASSOC);
        if ($meta)
        {
            $result .= "<INPUT TYPE=\"checkbox\" NAME=\"show_" . $meta['name'] . "\" CHECKED>" . $meta['name'];
        }
    }
    return($result);
}

function z_MakeSelectFieldsList($TableName)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;

    $zresult = $db->query("SELECT * FROM $TableName LIMIT 1");
    dberror($zresult);
    $zrow = $zresult->fetchRow(DB_FETCHMODE_ASSOC);
    $num_fields = $zresult->numCols();
    $c=4;
    $t=0;
    $result="\n<table border=0 width=\"100%\" cellspacing=2>\n\t<tr>\n";
    for ($nSort=0; $nSort<$num_fields; $nSort++)
    { 
        if ($t == $c)
        {
	    $result.="\t</tr>\n\t<tr>\n";
            $t=0;
        }
        $result .= "\t\t<td align=right width=15 valign=middle bgcolor=#bac2ca>". (string)($nSort+1) .".</td>\n";
        $result .= "\t\t<td align=center bgcolor=#bac2ca>\n\t\t\t<SELECT NAME=\"show_$nSort\" SIZE=1>\n";
        $options = '';
        $meta    = $zresult->tableInfo();
        for ($i=0; $i<$num_fields; $i++)
        {
            if ($meta)
            {
                $mname = $meta[$i]['name'];
                // print "\n nSort = $nSort , i = $i  ";
                if ($i == $nSort)
                {
                    $IS_SELECTED = 'SELECTED';
                } else {
                    $IS_SELECTED= '';
                }
                $options .= "\t\t\t\t<OPTION VALUE=\"" . $mname . "\" $IS_SELECTED> " . $mname . "\n";
            }
        }
        $result .= $options;
        $result .= "\t\t\t\t<OPTION VALUE=\"\" SIZE=1> -------- \n";
        $result .= "\t\t\t</SELECT> \n\t\t</td>\n";
        $t++;
    }
    $zresult->free();
    if ($t == $c)
    {
        $result.="\t</tr>\n</table>\n";
    } else {
        $r=($c - $t)*2;
        $result.="\t\t<td colspan=$r bgcolor=#bac2ca><hr width=75%></td>\n\t</tr>\n</table>\n";
    }
    return($result);
}

function z_MakeSortFieldsList($TableName)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;

    $result = ''; $options = '';
    $zresult = $db->query("SELECT * FROM $TableName LIMIT 1");
    dberror($zresult);
    $c=4;
    $t=0;
    $result="<table border=0 cellspacing=2 width=\"100%\">\n\t<tr>\n";
    $meta = $zresult->tableInfo();
    for ($i=0 ; $i<$zresult->numCols(); $i++)
    {
        if ($meta)
        {
            $mname    = $meta[$i]['name'];
            $options .= "\t\t\t\t<OPTION VALUE=\"" . $mname . "\"> " . $mname . "\n";
        }
    }
    $zresult->free();

    for ($nSort=1; $nSort<13 ; $nSort++)
    {
        if ($t == $c)
        {
	    $result.="\t</tr>\n\t<tr>\n";
            $t=0;
        }
        $result .= "\t\t<td align=right width=15 valign=middle bgcolor=#bac2ca>$nSort.</td>\n";
        $result .= "\t\t<td align=center bgcolor=#bac2ca>\n\t\t\t<SELECT NAME=\"sort_$nSort\" SIZE=1>\n";
        $result .= "\t\t\t\t<OPTION VALUE=\"\" SIZE=1 SELECTED> -------- \n";
        $result .= $options;
        $result .= "\t\t\t</SELECT> \n";
        $t++;
    }
    if ($t == $c)
    {
        $result.="\t</tr>\n</table>\n";
    } else {
        $r=($c - $t)*2;
        $result.="\t\t<td colspan=$r><hr width=75%></td>\n\t</tr>\n</table>\n";
    }
    return($result);
}

function z_CheckBoxesArray($handle, $SourceArray)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $l      = strlen($handle);
    $result = array();
    while (list($k,$v)= each($SourceArray))
    {
        if (!strncmp($k,$handle,$l))
        {
            $checked = substr($k, $l); 
            // print "<br> |$k|$v|$handle| ($checked)";   
            array_push($result, $checked);
        }
    }
    return($result);
}

function z_OrderedListArray($handle, $SourceArray)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $l      = strlen($handle);
    $result = array();
    while (list($k,$v)= each($SourceArray))
    {
        if (!strncmp($k,$handle,$l))
        {
            $checked = substr($k, $l); 
            // print "<br> |$k|$v|$handle| ($checked)";   
            $result[$checked] = $v;
        }
    }
    return($result);
}

function z_FormatFormDate($formatString, $datename, $SourceArray)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $day   = $SourceArray[$datename.'_day'];
    $month = $SourceArray[$datename.'_month'];
    $year  = $SourceArray[$datename.'_year'];
    return(date($formatString, mktime(0,0,0,$month,$day,$year)));
}

function z_MysqlDateRange($fieldName,$SourceArray)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $fromDate = z_FormatFormDate("Ymd000000",$fieldName .'_from',$SourceArray);
    $toDate   = z_FormatFormDate("Ymd000000",$fieldName .'_to',$SourceArray);
    if ($_CONF['db_type'] == "pgsql")
    {
        $result   = " ( (bugs.$fieldName >= $fromDate) and (bugs.$fieldName<=$toDate) ) ";
    } else {
        $result   = " ( (bugs.$fieldName >= $fromDate)&&(bugs.$fieldName<=$toDate) ) ";
    }
    return($result);
}

function z_ParseQueryArguments($SourceArray)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $ScalarVars = array("product","component","priority","severity","status",
		        "resolution","reporter","assigned");
    $Parameters = array();
    while (list($k,$v) = each ($ScalarVars) )
    {
        if (isset($SourceArray[$v]))
        {
            if ($SourceArray[$v] > -1)
            {
                array_push($Parameters," (bugs.$v = ".$SourceArray[$v].") ");
            }
            // if ($SourceArray[$v] > -1) print ("\n<br> (bugs.$v = ".$SourceArray[$v].") "); 	
        }
    }
    if (isset($SourceArray['mrange']))
    {
        if ($SourceArray['mrange'])
        {
            array_push($Parameters,z_MysqlDateRange('modified',$SourceArray) );
        }
    }
    if (isset($SourceArray['crange']))
    {
        if ($SourceArray['crange'])
        {
            array_push($Parameters,z_MysqlDateRange('creation',$SourceArray) );
        }
    }
    return($Parameters);
}


function z_ComposeQuery($Parameters,$SortList)
{
    global $_CONF;

    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    // substitute for what's defined.
    $user_options = NULL;
    while (list($k,$v) = each ($Parameters))
    {
        $user_options .= $v . " and "; 
    }
    $user_options .= " (1=1) ";

    $InOrder       = 0; 
    $ORDER_BY_LIST = ' order by ';
    while (list($k,$v) = each ($SortList))
    {
        if (strlen($v)>0)
        {
            $InOrder = 1;
            $ORDER_BY_LIST .= $v . ',';
        }
    }
    if ($InOrder)
    {
        $p = strrpos($ORDER_BY_LIST,',');
        if ($p)
        {
            $ORDER_BY_LIST = substr($ORDER_BY_LIST,0,$p);
        }
    } else {
        $ORDER_BY_LIST = '';
    }

    // PGSQL FIX: this query is not valid for postgres
    if ($_CONF['db_type'] == "pgsql")
    {
        $query = "\nselect bid, cc, private, url, products.name AS product, components.name AS component, versions.name AS version, shortdesc, severity_d.name AS severity,  "
               . "\n priority_d.name AS priority, status_d.name AS status, resolve_d.name AS resolution, u1.name AS assigned, u2.name AS reporter ,  "
               . "\n to_char(to_date(creation, 'YYYYMMDDHH24MISS'), 'Mon/DD/YY') AS creation, "
               . "\n to_char(to_date(modified, 'YYYYMMDDHH24MISS'), 'Mon/DD/YY') AS modified "
               . "\n from products,components,versions,status_d,priority_d,severity_d, users u1, users u2, bugs "
               . "\n left join resolve_d on bugs.resolution = resolve_d.id "
               . "\n where status_d.id = status and bugs.severity = severity_d.id and priority = priority_d.id "
               . "\n and bugs.product = products.pid and component = components.cid and version = versions.vid " 
               . "\n and u1.uid = bugs.assigned and u2.uid = bugs.reporter "
               . "\n and ($user_options) "
               . "\n $ORDER_BY_LIST ";
    } else {
        $query = "\nselect bid, cc, private, url, products.name product, components.name component, versions.name version, shortdesc, severity_d.name severity,  "
               . "\n priority_d.name priority, status_d.name status, resolve_d.name resolution, u1.name assigned, u2.name reporter ,  "
               . "\n DATE_FORMAT(creation,\"%b/%e/%y\") creation, DATE_FORMAT(modified,\"%b/%e/%y\") modified "
               . "\n from bugs,products,components,versions,status_d,priority_d,severity_d, users u1, users u2 "
               . "\n left join resolve_d on resolve_d.id = resolution "
               . "\n where status_d.id = status and bugs.severity = severity_d.id and priority = priority_d.id "
               . "\n and bugs.product = products.pid and component = components.cid and version = versions.vid " 
               . "\n and u1.uid = bugs.assigned and u2.uid = bugs.reporter "
               . "\n and ($user_options) "
               . "\n $ORDER_BY_LIST ";
    }
    return($query);
}

function z_PrintResultSet($Columns, $Query)
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $_CONF, $_USER, $db, $config;

    $zresult = $db->query($Query);
    dberror($zresult);

    print("<table>");
    print("<tr bgcolor=" . $config['barcol1'] . ">");
    reset($Columns);
    $innercol = $Columns;

    while (list($k, $v) = each($Columns))
    {
        if (strlen($v) > 0)
        {
            print("<td valign=\"top\"><font size=-1><b>$v</b></font></td>"); 
        }
    }
    print("</tr>"); 

    while ($row = $zresult->fetchRow(DB_FETCHMODE_ASSOC))
    {
        reset($innercol);
        print("<tr>"); 
        while (list($k, $v) = each($innercol))
        {
            if (strlen($v)>0)
            {
                if (strcmp($v,'bid'))
                {
                    $record = stripcslashes($row[$v]);
                    if ($v == "private")
                    {
                        if ($row[$v] == 0)
                        {
                            $record = "NO";
                        } else {
                            $record = "YES";
                       }
                    }
                    if ($v == "resolution")
                    {
                        if ($row[$v] == "OPEN")
                        {
                            $record = NULL;
                        }
                    }
                    print("<td bgcolor=#f2f2f2 valign=\"top\"> <font size=-1>$record</font> </td>");
                } else {
                    print("<td bgcolor=#f2f2f2 valign=\"top\"> <font size=-1><a href=\"query.php?bug=" . $row['bid'] . "\">" . $row['bid'] . "</font></td>");
                }
            }
        }
        print("</tr>");
    }
    print("</table>");
}

function z_ShowSelectionGrid()
{
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $config;

    print "<center><form action=query.php method=post>";
    print "<table bgcolor=#dae2ea cellpadding=0 border=1 width=640>";
    print "<tr><td align=center valign=middle><br>";
    print "<table bgcolor=#dae2ea cellpadding=3 border=1 width=600>";
    print "<tr><td>" . gettext("Product") . "   </td><td>" . z_MakeDropDown("product","products","pid","name",1) . "</td>";
    print "<td>" . gettext("Component") . " </td><td>" . z_MakeDropDown("component","components","cid","name",1) . "</td></tr>";
    print "<tr><td>" . gettext("Priority") . " </td><td>" . z_MakeDropDown("priority","priority_d","id","name",0) ."</td>";
    print "    <td>" . gettext("Severity") . " </td><td>" . z_MakeDropDown("severity","severity_d","id","name",0) ."</td></tr>";
    print "<tr><td>" . gettext("Status") . "   </td><td>" . z_MakeDropDown("status","status_d","id","name",0) . "</td>";
    print "<td> " . gettext("Resolution") . " </td><td>" . z_MakeDropDown("resolution","resolve_d","id","name",0) . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td colspan=4> <input type=radio name=crange value=0 checked> " . gettext("Submited anytime !") . "</td></tr>";
    print "<tr><td> <input type=radio name=crange value=1> " . gettext("Between") . " </td> " 
         ."<td>" . z_MakeDateRangeDropDown("creation_from") . "</td>";
    print "<td> And </td><td>" . z_MakeDateRangeDropDown("creation_to") . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td colspan=4> <input type=radio name=mrange value=0 checked> " . gettext("Modified anytime !") . "</td></tr>";
    print "<tr><td> <input type=radio name=mrange value=1> " . gettext("Between") . " </td> " 
         ."<td>" . z_MakeDateRangeDropDown("modified_from") . "</td>";
    print "<td> And </td><td>" . z_MakeDateRangeDropDown("modified_to") . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=1 width=600>";
    print "<tr><td> " . gettext("Reported By") . "   </td><td>" . z_MakeDropDown("reporter","users","uid","name",1) . "</td>";
    print "<td> " . gettext("Assigned To") . " </td><td>" . z_MakeDropDown("assigned","users","uid","name",1) . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td> " . gettext("Fields to Display:") . " <b><br><font size=-2> ";
    print z_MakeSelectFieldsList("bugs") . "</font></td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td> " . gettext("Sort Fields") . "<br> <b><font size=1>";
    print  z_MakeSortFieldsList("bugs") . "</font></td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "\n<tr><td colspan=2>&nbsp;</td></tr>";
    print "<tr><td align=center><input type=submit name=btnQuery value=\"" . gettext("Run Query") . "\"></td></tr>";
    print "</table>";
    print "</td></tr></table>";
    print "</form></center>";
    print "<br>";
}

?>
