<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: config.inc-dist.php,v 1.25 2004/02/11 19:05:17 vdanen Exp $
//
// Anthill configuration file
// during upgrades you probably shouldn't replace this file

/****************************************************************************
 * Directory locations:
 *
 * root:	base Anthill directory+html/ (ie. /var/www/anthill/html)
 * incdir:	include directory (full path)
 * webroot:	home url
 * imgdir:	images directory
 * tmpldir:	templates directory
 * langdir:	directory where locale/language files/dirs are kept
 * shadodir:	shadow directory (stores text copy of bugs for diffs)
 * tmpdir:	temporary directory (should be rw to user running the 
 *		web server; ie. apache or nobody)
 * gpgdir:	directory to store GPG keys (should be rw only to web 
 *		server user; located off of the root directory)
 * attachdir:  directory to store attachments (should be rw only to web
 *             server user; located off of the root directory)
 * cssfile:	default stylesheet file
 * peardir:    path to PEAR - must include a trailing slash!
 *             (use "" to use the system install)
 * includes:   additional include directories (additional to those in
 *             php.ini); peardir or the system-wide pear must be included
 *             here
 * difftool:   path to the diff program
 * buffer:     whether or not to use output buffering (depending on your web
 *             server/browser you may wish to turn this off)
 ***************************************************************************/

$_CONF['root']       = "/var/www/html/anthill";
$_CONF['incdir']     = "/var/www/html/anthill/include";
$_CONF['webroot']    = "http://localhost";
$_CONF['imgdir']     = "/images";
$_CONF['tmpldir']    = "/backend/template";
$_CONF['langdir']    = "/backend/language";
$_CONF['shadowdir']  = $_CONF['root'] . "/shadow";
$_CONF['tmpdir']     = $_CONF['root'] . "/tmp";
$_CONF['gpgdir']     = "/gpg";
$_CONF['attachdir']  = "/attachments";
$_CONF['cssfile']    = $_CONF['webroot'] . "/anthill.css";
$_CONF['peardir']    = $_CONF['incdir'] . "/pear/";
$_CONF['includes']   = $_CONF['peardir'];

$_CONF['difftool']   = "/usr/bin/diff";
$_CONF['buffer']     = 1;

/****************************************************************************
 * Time/date details:
 *
 * datefmt:	  date format to use (see PHP manual for proper syntax)
 * timefmt:	  time format to use (see PHP manual for proper syntax)
 ***************************************************************************/

$_CONF['datefmt']     = "Y-m-d";
$_CONF['timefmt']     = "h:i A";

/****************************************************************************
 * Cookie details:
 *
 * _timeout_permdef: default seconds for cookie expiry for permanent cookies
 *                 (can be overriden by users in their prefs)
 *                 (86400 = one day)
 *                 useful if you don't want persistent cookies)
 * cookie_name:    unique name for the name of the cookie
 * cookie_session: unique name for the session cookie
 * cookie_path:    cookie path (usually just '/'): If Anthill is installed
 *                 as the primary site (ie: http://mysite.com/) then '/' is
 *                 all you need.  If it is reachable as
 *                 http://mysite.com/anthill/ then you need to use '/anthill'.
 * cookie_domain:  the domain in which the cookie should be sent to server
 *                 for (default is $SERVER_NAME, which is the name of the
 *                 running server, but you can change this if you need to)
 * cookie_secure:  0=HTTP, 1=HTTPS (does site run over SSL?)
 ***************************************************************************/

$_CONF['cookie_timeout_permdef']    = "86400";
$_CONF['cookie_timeout_session']    = "7200";
$_CONF['cookie_name']               = "anthill";
$_CONF['cookie_session']            = "ant_session";
$_CONF['cookie_path']               = "/";
$_CONF['cookie_domain']             = $_SERVER['SERVER_NAME'];
$_CONF['cookie_secure']             = 0;

/****************************************************************************
 * Language details:
 *
 * meta_lang:	charset to send to browser and set in email messages (meta
 *              tag)
 ***************************************************************************/

$_CONF['meta_lang'] = "utf-8";

/****************************************************************************  
 * Mail details:
 *
 * forcereturn:	whether to use -f with the MTA to force setting the
 * 			Return-Path correctly (see README.html for more info)
 *			NOTE: do not change this if you don't know if you
 *			need this!!
 * crlf:        the line ending to use on emails (\n is the default,
 *                      change to \r\n if emails are sent out looking odd as
 *                      this is highly dependent on the server MTA
 ***************************************************************************/

$_CONF['forcereturn'] = "0";
$_CONF['crlf']        = "\n";

/****************************************************************************
 * SQL connection info:
 *
 * db_user:    SQL username
 * db_pw:      SQL user's password
 * db_host:    SQL server hostname
 * db_name:    SQL database name
 * db_type:    SQL database type ("mysql" or "pgsql"); currently only mysql
 *             is support
 ***************************************************************************/

$_CONF['db_user']    = "anthill";
$_CONF['db_pw']      = "pass";
$_CONF['db_host']    = "localhost";
$_CONF['db_name']    = "anthill";
$_CONF['db_type']    = "mysql";  

/****************************************************************************
 * Debugging:
 *
 * debug:	Whether or not to enable debug logging
 * debug_log:	If set, debug errors will be written to this log and a
 *		generic error message will go to the browser, if unset the
 *		debug info will go to the browser.  NOTE: this must be
 *		defined, even if it's value is only "".
 ***************************************************************************/

$_CONF['debug']      = 1;
// $_CONF['debug_log']  = "";  // STDOUT
$_CONF['debug_log']  = "/var/www/html/anthill/debug.log";

/***** DO NOT TOUCH ANYTHING BELOW THIS LINE *******************************/

if (file_exists($_CONF['incdir'] . "/site.inc.php"))
{
    include_once($_CONF['incdir'] . "/site.inc.php");
} else {
    print("<p><b><font=red>Configuration file doesn't exist!!</font></b></p>");
}

?>
