<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: site.inc.php,v 1.62 2004/02/09 07:08:12 vdanen Exp $

if ($_CONF['buffer'] == 1)
{
    ob_start('ob_gzhandler');
}

if ($_CONF['debug'] == 1)
{
    error_reporting(E_ALL);
} else {
    error_reporting(0);
}

define("_VERSION","0.3.0");
define("_NAME","Anthill");

// set our include_path in PHP so we can handle PEAR transparently
$oldinc = ini_get("include_path");
if ($oldinc == "")
{
    $add = "";
} else {
    $add = ":";
}
ini_set("include_path", $oldinc . $add . $_CONF['includes']);

$rtmpldir   = $_CONF['root'] . $_CONF['tmpldir'];
$wtmpldir   = $_CONF['webroot'] . $_CONF['tmpldir'];

if (file_exists($_CONF['incdir'] . "/user.inc.php")) { include_once($_CONF['incdir'] . "/user.inc.php"); }
if (file_exists($_CONF['incdir'] . "/functions.inc.php")) { include_once($_CONF['incdir'] . "/functions.inc.php"); }
if (file_exists($_CONF['incdir'] . "/advancedquery.inc.php"))
{
    include_once($_CONF['incdir'] . "/advancedquery.inc.php");
    $_CONF['advq'] = 1;
} else {
    $_CONF['advq'] = 0;
}

// primary database connection
require_once($_CONF['peardir'] . "DB.php");
$dsn = $_CONF['db_type'] . "://" . $_CONF['db_user'] . ":" . $_CONF['db_pw'] . "@" . $_CONF['db_host'] . "/" . $_CONF['db_name'];
$db  = DB::connect($dsn);
if (DB::isError($db))
{
    die ($db->getMessage());
}
$db->setOption('optimize', 'portability');

$result = $db->query("SELECT * FROM config");
dberror($result);

$config     = array();
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
{
    $config[$row['name']] = $row['value'];
}
$result->free();

// set language
$BROWSER_LANGUAGE = "";
if (!(ereg("showattachment.php", $PHP_SELF, $match)))
{
    if ($_SERVER['HTTP_ACCEPT_LANGUAGE'])
    {
        $tmp = strtok($_SERVER['HTTP_ACCEPT_LANGUAGE'], ",");
        while ($tmp)
        {
            while ($tmp[0] == " ") $tmp = substr($tmp, 1);
            $BROWSER_LANGUAGE = $BROWSER_LANGUAGE . ereg_replace("-","_",$tmp) . ":";
            $tmp = strtok(",");
        }
    }
    if (substr($BROWSER_LANGUAGE, 0, 2) != "en")
    {
        putenv(sprintf("LANGUAGE=%s",$BROWSER_LANGUAGE));
        putenv("LC_ALL=UTF-8");
        // setlocale(LC_ALL, $BROWSER_LANGUAGE); // this may be necessary?
        setlocale(LC_ALL, "");
        bindtextdomain("Anthill", $_CONF['root'] . $_CONF['langdir']);
        textdomain("Anthill");
    }
}

// session checking; is user logged in?
$_USER = do_sessioncheck();
$user  = $_USER; // compatability

// handle persistent cookies
if (!isset($_COOKIE[$_CONF['cookie_name']]) || !isset($_COOKIE['password']))
{
    // either their cookie expired or they are new
    $cookietime = do_getusercookietimeout();
    if (!empty($cookietime))
    {
        // persistent cookie
        setcookie($_CONF['cookie_name'],$_USER['uid'],time() + $cookietime,$_CONF['cookie_path'],$_CONF['cookie_domain'],$_CONF['cookie_secure']);
        setcookie('password',$_USER['passwd'],time() + $cookietime,$_CONF['cookie_path'],$_CONF['cookie_domain'],$_CONF['cookie_secure']);
    }
} else {
    $userid = $_COOKIE[$_CONF['cookie_name']];
    if ($userid)
    {
        $user_logged_in = 1;
        // create new session
        $userdata       = do_getuserdatafromid($userid);
        $_USER          = $userdata;
    }
}

if (file_exists(sprintf("%s/%s/theme.php", $rtmpldir, $config['theme'])))
{
    include_once(sprintf("%s/%s/theme.php", $rtmpldir, $config['theme']));
}

?>
