<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: index.php,v 1.22 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

d_StartPage(gettext("Welcome to Anthill"));
d_DrawNav($_USER['uname']);

// set all the $p_string_*'s to NULL
$p_string = array('logout' => NULL, 'pref' => NULL, 'submit' => NULL, 'reported' => NULL,
                  'open' => NULL, 'login' => NULL, 'newu' => NULL, 'unres' => NULL,
                  'val' => NULL, 'summ' => NULL, 'text' => NULL, 'header1' => NULL,
                  'header2' => NULL, 'faq' => NULL, 'welcome' => NULL, 'content' => NULL);

if (isset($_USER['uname']))
{
    $p_string['logout']   = "<a href=\"logout.php\">" . gettext("Logout") . "</a><br />";
    $p_string['pref']     = "<a href=\"pref.php\">" . gettext("Preferences") . "</a><br />";
    $p_string['submit']   = "<a href=\"enterbug.php\">" . gettext("Submit a bug") . "</a><br />";
    $p_string['reported'] = "<a href=\"buglist.php?type=reporternew\">" . gettext("New bugs you reported") . "</a><br />";
    $p_string['open']     = "<a href=\"buglist.php?type=mine&myclass=new\">" . gettext("Your open bugs") . "</a><br />";
} else {
    $p_string['login']    = "<a href=\"login.php\">" . gettext("Login") . "</a><br />";
    if ($config['newusers'] == 1)
    {
        $p_string['newu']   = "<a href=\"newuser.php\">" . gettext("Create new account") . "</a><br />";
    }
}
if (isset($_USER['uname']) || $config['newusers'] == 1)
{
    $p_string['unres']   = "<a href=\"buglist.php?type=unres\">" . gettext("Unresolved bugs") . "</a><br />";
    $p_string['val']     = "<a href=\"buglist.php?type=all&allclass=7\">" . gettext("Bugs requiring validation") . "</a><br />";
    $p_string['summ']    = "<a href=\"reports.php\">" . gettext("Summary reports") . "</a><br />";
    $p_string['text']    = "<a href=\"textreport.php\">" . gettext("Downloadable text reports") . "</a><br />";
    $p_string['header2'] = gettext("Problem Tracking");
}
$p_string['faq']       = "<a href=\"faq.php\">" . gettext("Problem tracking help") . "</a><br />";
$p_string['header1']   = gettext("Accounting");
$p_string['welcome']   = sprintf(gettext("Welcome to %s Anthill"), $config['sitename']);
$p_string['content']   = stripslashes($config['siteblurb']);
  
$data = <<<EOT
    <table border="0" cellpadding="0" cellspacing="0" align="center" width="95%">
        <tr>
            <td>
                <table border="0" cellpadding="0" cellspacing="0" align="center" bgcolor="#000000" width="100%">
                    <tr>
                        <td>
                            <table border="0" cellpadding="2" cellspacing="2" width="100%">
                                <tr>
                                    <td bgcolor="#dddddc" width="100%"><big><b>{$p_string['welcome']}</b></big></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
    <br /><br />
    <table border="0" cellpadding="0" cellspacing="0" align="center" width="95%">
        <tr>
            <td width="20%" valign="top">
                <table border="0" cellpadding="1" cellspacing="0" width="100%">
                    <tr>
                        <td valign="top" bgcolor="{$config['barcol1']}"><b>{$p_string['header1']}</b></td>
                    </tr>
                    <tr>
                        <td valign="top"><br />
                            {$p_string['login']}
                            {$p_string['logout']}
                            {$p_string['newu']}
                            {$p_string['pref']}
                            {$p_string['faq']}
                            <br />
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" bgcolor="{$config['barcol1']}"><b>{$p_string['header2']}</b></td>
                    </tr>
                    <tr>
                        <td valign="top"><br />
                            {$p_string['submit']}
                            {$p_string['reported']}
                            {$p_string['open']}
                            {$p_string['unres']}
                            {$p_string['val']}
                            {$p_string['summ']}
                            {$p_string['text']}
                            <br />
                        </td>
                    </tr>
                </table>
            </td>
            <td width="5%">&nbsp;</td>
            <td width="75%" valign="top">
                {$p_string['content']}
            </td>
        </tr>
    </table>
EOT;

print($data);
d_DrawFooter();
?>
