<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: newuser.php,v 1.46 2004/02/11 19:05:17 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['go']))    { $go    = $_REQUEST['go']; }    else { $go    = NULL; }
if (isset($_REQUEST['email'])) { $email = $_REQUEST['email']; } else { $email = NULL; }
if (isset($_REQUEST['uname'])) { $uname = $_REQUEST['uname']; } else { $uname = NULL; }
if (isset($_REQUEST['rname'])) { $rname = $_REQUEST['rname']; } else { $rname = NULL; }
if (isset($_REQUEST['admin'])) { $admin = $_REQUEST['admin']; } else { $admin = NULL; }

d_StartPage(gettext("New User Registration"));

// generate new password for existing user
if ($go == "newpass")
{
    // $email, $uname
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("New User Registration"));

    $result = $db->query("SELECT * FROM users WHERE (uname = '$uname') AND (deleted='0')");
    dberror($result);
    $user   = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();
    
    if (!isset($user['uname']))
    {
        print("<p>" . gettext("The username supplied does not exist on this system.") . "</p>");
        d_DrawFooter();
        exit;
    }

    if ($user['email'] == $email)
    {
        $newpass  = do_newPass($uname);
        $cpass    = md5($newpass);
        $result   = $db->query("UPDATE users SET passwd = '$cpass' WHERE (uid=" . $user['uid'] . ") ");
        dberror($result);

        // get the maximum string length to format the email nicely
        // arbitrarily english email
        $msg[0]   = "Login name";
        $msg[1]   = "Password";
        $limit    = count($msg);
        $size     = 0;
        for ($i=0; $i < $limit; $i++)
        {
            if (strlen($msg[$i]) > $size)
            {
                $size = strlen($msg[$i]);
            }
        }
        for ($i=0; $i < $limit; $i++)
        {
            $buff = $size - strlen($msg[$i]);
            if ($buff > 0)
            {
                $msg[$i] = $msg[$i] . str_repeat(" ", $buff);
            }
        }

        $message  = "In order to use Anthill, you must use the following to log in:\n\n";
        $message .= $msg[0] . ": " . $user['uname'] . "\n";
        $message .= $msg[1] . ": " . $newpass . "\n\n";
        $message .= "To change your password, log in and go to \"Preferences\".\n";
        $message .= "\n--\n" . $_CONF['webroot'] . "\n";
      
        $headers  = "Date: " . date("r") . $_CONF['crlf'];
        $headers .= "From: " . $config['mdaemon'] . " <" . $config['memail'] . ">" . $_CONF['crlf'];
        $headers .= "Return-Path: <" . $config['memail'] . ">" . $_CONF['crlf'];
        $headers .= "X-Mailer: " . _NAME . " " . _VERSION . $_CONF['crlf'];
      
        $addparam = forcereturn();
        if ($addparam != "")
        {
            $retval   = @mail($user['name'] . " <" . $user['email'] . ">",
                        "Your Anthill password", $message, $headers, $addparam);
        } else {
            $retval   = @mail($user['name'] . " <" . $user['email'] . ">",
                        "Your Anthill password", $message, $headers);
        }
        print("<p>" . sprintf(gettext("A new password has been emailed to %s."), $email) . "</p>");
    } else {
      print("<p>" . sprintf(gettext("The username you entered: <b>%s</b> does not match the supplied email address: <b>%s</b>."), $uname, $email));
      print(sprintf(gettext("Please go back and enter your proper email address and user name.  If you have forgotten your username, please email the <a href=\"mailto:%s\">administrator</a>."), $config['adminemail']) . "</p>");
    }
    d_DrawFooter();
    exit;
}

// generate new user
if ($go == "newuser")
{
    if ($config['newusers'] == 0)
    {
        print("<p>" . gettext("New users are not permitted to register.") . "</p>");
        d_DrawFooter();
        exit;
    }
    $msg = do_checkUser($uname, $email, 0, 0);
    if (!isset($msg))
    {
        if (isset($_USER['uid']) && $_USER['access'] >= $config['adminac'])
        {
            $msg = "<span class=\"text\"><center>" . sprintf(gettext("Password has been emailed to %s.  You can return to <a href=\"editusers.php\">Edit User Preferences</a>."), $email);
        } else {
            $msg = "<span class=\"text\"><center>" . sprintf(gettext("Thank you for registering.  A password has been emailed to %s.  Use this password to log into %s."), $email, $config['sitename']) . "</center></span>";
        }

        $newpass  = do_newPass($uname);
        $now      = date("YmdHis");
        $cpass    = md5($newpass);

        $id       = $db->nextID('users');
        if ($id == "1")
        {
            $id     = $db->nextID('users');
        }
        $query    = "INSERT INTO users (uid, name, uname, email, passwd, ";
        $query   .= "access, laston) VALUES ";
        $query   .= "('$id','" . addslashes(htmlspecialchars($rname)) . "',";
        $query   .= "'" . addslashes(htmlspecialchars($uname)) . "',";
        $query   .= "'" . addslashes(htmlspecialchars($email)) . "',";
        $query   .= "'$cpass','1','$now') ";
        $result   = $db->query($query);
        dberror($result);

        // get the maximum string length to format the email nicely
        $emsg[0]  = "Login name";
        $emsg[1]  = "Password";
        $limit    = count($emsg);
        $size     = 0;
        for ($i=0; $i < $limit; $i++)
        {
            if (strlen($emsg[$i]) > $size)
            {
                $size = strlen($emsg[$i]);
            }
        }
        for ($i=0; $i < $limit; $i++)
        {
            $buff = $size - strlen($emsg[$i]);
            if ($buff > 0)
            {
                $emsg[$i] = $emsg[$i] . str_repeat(" ", $buff);
            }
        }

        $message  = "In order to use Anthill, you must use the following to log in:\n\n";
        $message .= $emsg[0] . ": " . $uname . "\n";
        $message .= $emsg[1] . ": " . $newpass . "\n\n";
        $message .= "To change your password, log in and go to \"Preferences\"\n";
        $message .= "\n--\n" . $_CONF['webroot'] . "\n";
      
        $headers  = "Date: " . date("r") . "\r\n";
        $headers .= "From: " . $config['mdaemon'] . " <" . $config['memail'] . ">\r\n";
        $headers .= "Return-Path: <" . $config['memail'] . ">\r\n";
        $headers .= "X-Mailer: " . _NAME . " " . _VERSION;
        $addparam = forcereturn();
        if ($addparam != "")
        {
            $retval   = @mail($email,
                        "Your Anthill password", $message, $headers, $addparam);
        } else {
            $retval   = @mail($email,
                        "Your Anthill password", $message, $headers);
        }
    }
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("New User Registration"));
    print($msg);

    d_DrawFooter();
    exit;
}

// load form
d_DrawNav($_USER['uname']);
d_DrawHeader(gettext("New User Registration"));

if (isset($_USER['uid']) && $_USER['access'] >= $config['adminac'] && $admin == 1)
{
    d_DrawNewUser();
} elseif ($config['newusers'] == 1) {
    d_DrawNewUser();
} else {
    print("<p>" . sprintf(gettext("We're sorry... this is a private site and new users must be added by the administrator.  Try sending an email to request access to <a href=\"mailto:%s\">%s</a>."), $config['adminemail'], $config['adminemail']) . "</p>");
    d_DrawNewUser("1");
}

d_DrawFooter();
?>
