<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: postbug.php,v 1.32 2004/02/04 16:54:52 vdanen Exp $
  
include("include.php");

// set variables
if (isset($_REQUEST['reporter']))  { $reporter  = $_REQUEST['reporter']; }  else { $reporter  = NULL; }
if (isset($_REQUEST['product']))   { $product   = $_REQUEST['product']; }   else { $product   = NULL; }
if (isset($_REQUEST['version']))   { $version   = $_REQUEST['version']; }   else { $version   = NULL; }
if (isset($_REQUEST['component'])) { $component = $_REQUEST['component']; } else { $component = NULL; }
if (isset($_REQUEST['prior']))     { $prior     = $_REQUEST['prior']; }     else { $prior     = NULL; }
if (isset($_REQUEST['sever']))     { $sever     = $_REQUEST['sever']; }     else { $sever     = NULL; }
if (isset($_REQUEST['status']))    { $status    = $_REQUEST['status']; }    else { $status    = NULL; }
if (isset($_REQUEST['assigned']))  { $assigned  = $_REQUEST['assigned']; }  else { $assigned  = NULL; }
if (isset($_REQUEST['shortdesc'])) { $shortdesc = $_REQUEST['shortdesc']; } else { $shortdesc = NULL; }
if (isset($_REQUEST['longdesc']))  { $longdesc  = $_REQUEST['longdesc']; }  else { $longdesc  = NULL; }
if (isset($_REQUEST['url']))       { $url       = $_REQUEST['url']; }       else { $url       = NULL; }

if (!isset($product))
{
    header("Location: enterbug.php");
    exit;
}

d_StartPage(gettext("Posting Bug"));
d_DrawNav($_USER['uname']);
d_DrawHeader(gettext("Posting Bug"));

if (!isset($_USER['uid']))
{
    print("<p>" . gettext("You must login to access this page.") . "</p>");
    d_DrawFooter();
    exit;
}    

// reporter (uid), product (pid), version (vid), component (cid)
// priority, severity, assigned (uid), shortdesc, longdesc

// get the default status
$status = $db->getOne("SELECT id FROM status_d WHERE s_def = '1'");

if ($assigned == 0)
{
    // chosen to assign to component owner
    $assigned = $db->getOne("SELECT owner FROM components WHERE cid = '$component'");
}
  
$access = $db->getOne("SELECT access FROM users WHERE uid = '$assigned'");
if ($access < $config['devac'])
{
    // assigned user's access is lower than developer access
    print("<span class=\"text\"><center>" . gettext("ERROR: You have assigned the bug to someone unauthorized to own bugs.") . "</center></span><br />");
    d_drawFooter();
    exit;
}

if ($shortdesc == "")
{
    // no short description entered
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to include a summary of the bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
}

if ($longdesc == "")
{
    // no long description entered
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to include a description of the bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
}

if ($version == 0)
{
    // no version chosen
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to select a version for this bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
}

if ($component == 0)
{
    // no component chosen
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to select a component for this bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
}

// create the autocc string
$autocc = $db->getOne("SELECT autocc from components WHERE cid = '$component'");
if ($config['autocc'] != "")
{
    if ($autocc != "")
    {
        $autocc = $config['autocc'] . ", " . $autocc;
    } else {
        $autocc = $config['autocc'];
    }
}
$creation = date("YmdHis");  // use same format as timestamp
$id       = $db->nextID('bugs');
$query    = "INSERT INTO bugs (bid, assigned, severity, status, creation, ";
$query   .= "modified, shortdesc, priority, product, reporter, version, ";
$query   .= "component, resolution, cc, private, url) VALUES ";
$query   .= "('$id','$assigned','$sever','$status', ";
$query   .= "'$creation', '$creation', '" . addslashes($shortdesc) . "', ";
$query   .= "'$prior','$product','$reporter','$version','$component', ";
$query   .= "'4', '$autocc', ". $config['defpriv'] . ", ";
$query   .= "'" . trim(addslashes($url)) . "')";
$result   = $db->query($query);
dberror($result);
$bugnum   = $db->getOne("SELECT bid FROM bugs ORDER BY bid DESC");
$id       = $db->nextID('bugdesc');
$query    = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
$query   .= "('$id','$bugnum','$reporter','$creation',0,";
$query   .= "'" . addslashes($longdesc) . "')";
$result   = $db->query($query);
dberror($result);

d_doDiff($bugnum);

print("<p><b>" . sprintf(gettext("Bug #%s posted"), $bugnum) . ".</b></p>");
print("<p><a href=\"query.php?bug=$bugnum\">" . sprintf(gettext("Back to Bug #%s"), $bugnum) . "</a>&nbsp;&nbsp;&nbsp;&nbsp;");
print("<a href=\"enterbug.php\">" . gettext("Enter another bug") . "</a>&nbsp;&nbsp;&nbsp;&nbsp;</p>");

d_DrawFooter();
?>
