<?php 
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: textreport.php,v 1.12 2004/02/04 16:54:53 vdanen Exp $

// Create the headers; define a date in the past, always modified
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");                                    // HTTP/1.0

// set variables
if (isset($_REQUEST['repval'])) { $repval = $_REQUEST['repval']; } else { $repval = NULL; }

if (isset($repval))
{
    if ($repval == "total")
    {
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=" . $repval . ".txt");
    }
}

include("include.php");
if (!isset($repval))
{
    d_StartPage(gettext("Text Bug Reports"));
}

if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) exit;

if (!isset($repval))
{
    d_DrawNav($user['uname']);
    d_DrawHeader(gettext("Select Report"));

    $p_string['selrep'] = gettext("Select Report");
    $p_string['cont']   = gettext("Continue");

    $data = <<<EOT
        <form method="post" action="textreport.php">
        <table border="0" cellpadding="0" cellspacing="0" width="40%" align="center">
            <tr>
                <td width="50%" align="right">{$p_string['selrep']}:</td>
                <td width="50%">
                    <select name="repval">
                    <option value="total">Total</option>
                    <option value="partial">Partial</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td width="50%">&nbsp;</td>
                <td width="50%"><input type="submit" value="{$p_string['cont']}"></td>
            </tr>
        </table>
        </form>
EOT;

    print($data);
    d_DrawFooter();
    exit;
}

$date = gmdate(sprintf("%s %s", $_CONF['datefmt'], $_CONF['timefmt']));
switch($repval)
{
    case "total":
        if (file_exists($_CONF['incdir'] . "/reportengine.php"))
        {
            include_once($_CONF['incdir'] . "/reportengine.php");
        }
        report_init(58, 80, 1, 0, gettext("Total bug information report"), 2, 2);
        // PGSQL FIX: this query is not valid for postgresql
        if ($_CONF['db_type'] == "pgsql")
        {
            $query = "SELECT bid, u2.name as assigned_user,
                severity_d.name as severity_name,
                status_d.name as status_name,
                creation, modified, shortdesc,
                priority_d.name as priority_name,
                products.name as product_name,
                users.name as reporter_user,
                versions.name as version_name,
                components.name as component_name,
                COALESCE(resolve_d.name,'UNRESOLVED') as resolve_info, cc,
                case private when 0 then 'Public' when 1 then 'Private' else 'Unknown' end, url
                FROM priority_d, users, users as u2, severity_d, status_d, versions, products, components, bugs
                LEFT JOIN resolve_d ON (bugs.resolution = resolve_d.id)
                WHERE (bugs.priority = priority_d.id) and (bugs.reporter = users.uid) and (bugs.assigned = u2.uid)
                and (bugs.severity = severity_d.id) and (bugs.status = status_d.id) and (bugs.version = versions.vid)
                and (bugs.product = products.pid) and (bugs.component = components.cid)
                ORDER BY bid;";
        } else {
            $query = "SELECT bid, u2.name as assigned_user,
                severity_d.name as severity_name,
                status_d.name as status_name,
                creation, modified, shortdesc,
                priority_d.name as priority_name,
                products.name as product_name,
                users.name as reporter_user,
                versions.name as version_name,
                components.name as component_name,
                IFNULL(resolve_d.name,\"UNRESOLVED\") as resolve_info, cc,
                case private when 0 then \"Public\" when 1 then \"Private\" else \"Unknown\" end, url
                FROM bugs, priority_d, users, users as u2, severity_d, status_d, versions, products, components
                LEFT JOIN resolve_d ON (bugs.resolution = resolve_d.id)
                WHERE (bugs.priority = priority_d.id) and (bugs.reporter = users.uid) and (bugs.assigned = u2.uid)
                and (bugs.severity = severity_d.id) and (bugs.status = status_d.id) and (bugs.version = versions.vid)
                and (bugs.product = products.pid) and (bugs.component = components.cid)
                ORDER BY bid;";
        }
        $result = $db->query($query);
        dberror($result);
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
        {
            report_que_line("");
            report_que_line(gettext("Bug      Priority Severity    Status      Modified              Resolution"));
            $cdate = d_getTimeGMT($row['creation']);
            $mdate = d_getTimeGMT($row['modified']);
            if ($row['resolve_info'] == "OPEN")
            {
                $row['resolve_info'] = "";
            }
            report_que_line(sprintf("%-8d %-8s %-11s %-11s %-21s %-8s", 
                $row['bid'],
                $row['priority_name'],
                $row['severity_name'],
                $row['status_name'],
                $mdate,
                $row['resolve_info']));
            // some gettext length magic
            report_que_line(sprintf("        Assignee: %s", $row['assigned_user']));
            report_que_line(sprintf("        Reporter: %s", $row['reporter_user']));
            report_que_line(sprintf("         Created: %s", $cdate));
            report_que_line(sprintf("         Product: %s", $row['product_name']));
            report_que_line(sprintf("       Component: %s", $row['component_name']));
            report_que_line(sprintf("         Version: %s", $row['version_name']));
            report_que_line(sprintf(" Bug Description: %s", stripslashes($row['shortdesc'])));
            if (strlen($row['url']) > 0)
            {
                report_que_line(sprintf("URL: %s", stripslashes($row['url'])));
            }
            $result2 = $db->query("SELECT description, b_date, users.name as uname FROM bugdesc, users WHERE (bid='" . $row['bid'] . "') AND (bugdesc.b_user = users.uid) ORDER BY b_date");
            dberror($result2);
            $firsttime = 1;
            while ($row2 = $result2->fetchRow(DB_FETCHMODE_ASSOC))
            {
                if ($firsttime == 1)
                {
                    report_que_line(gettext("Long description:"));
                    $firsttime = 0;
                } else {
                    $xdate = d_getTimeGMT($row2['b_date']);
                    report_que_line(sprintf("On %s, %s said:",$xdate,$row2['uname']));
                }
                $outstring = ereg_replace("  "," ",ereg_replace("\n"," ",ereg_replace("\r","", stripslashes($row2['description']))));
                report_flowtext($outstring,2);
            }
            $result2->free();

            $result2 = $db->query("SELECT b_date, what, oldval, newval, name FROM bugactivity, users WHERE (bid = '" . $row['bid'] . "') AND (bugactivity.b_user = users.uid) ORDER BY b_date");
            dberror($result2);
            while ($row2 = $result2->fetchRow(DB_FETCHMODE_ASSOC))
            {
                report_que_line("");
                report_que_line(sprintf(" Who: %s", $row2['name']));
                switch($row2['what'])
                {
                    case 0:
                        report_que_line(gettext("What: Status Change")); break;
                    case 1:
                        report_que_line(gettext("What: Reassigned")); break;
                    case 2:
                        report_que_line(gettext("What: State Change")); break;
                    case 3:
                        report_que_line(gettext("What: Added to CC")); break;
                    case 4:
                        report_que_line(gettext("What: Removed from CC")); break;
                }
                // more gettext length magic
                report_que_line(sprintf(" Old: %s", $row2['oldval']));
                report_que_line(sprintf(" New: %s", $row2['newval']));
                report_que_line(sprintf("When: %s", d_getTimeGMT($row2['b_date'])));
            }
         
            report_que_line("");
        }
        $result->free();
        report_que_line(sprintf(gettext("Report generated on %s GMT."), $date));

        report_finish();
        break;
    case "partial":
        d_DrawNav($user['uname']);
        d_DrawHeader(gettext("Partial bug information report"));
        printf("Partial bug information report not implemented\n");
        d_DrawFooter();
        break;
}

?>
