<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: upgrade.php,v 1.5 2004/02/04 16:54:53 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['go']))   { $go = $_REQUEST['go'];     } else { $go = NULL;   }
if (isset($_REQUEST['over'])) { $over = $_REQUEST['over']; } else { $over = NULL; }

d_StartPage(gettext("Upgrade Anthill"));
d_DrawNav($_USER['uname']);
d_DrawHeader("Upgrading Anthill");

if (!do_checkacs($_USER['access'])) exit;

function udberror($result, $query)
{
    // db error handler for upgrades
    if (DB::isError($result)) 
    {
        print("<font color=\"red\">An error occured on the query</font>: $query .... continuing...<br>");
        return(1);
    }
    return(0);
}

if (isset($go))
{
    if ($config['version'] != "")
    {
        $oldversion = $config['version'];
    } else {
        $oldversion = $over;
    }
    print("<p>Upgrading Anthill from version <b>$oldversion</b> to version <b>" . _VERSION . "</b>.</p>");
    // do the update sequentially
    if ($over == "020")
    {
        print("<p>Updating database from 0.2.0 to 0.2.1...</p>");
        // upgrade from 0.2.0 to 0.2.1
        $query = "ALTER TABLE users ADD epref int(1) DEFAULT '1'";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Added epref to users<br>");

        $query = "ALTER TABLE users ADD cookietimeout int(8) DEFAULT '0'";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added cookietimeout to users<br>");

        $query = "INSERT INTO config (id, name, value) VALUES (20,'devac','10')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added devac to config<br>");

        $query = "INSERT INTO config (id, name, value) VALUES (21,'defaultac','1')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added defaultac to config<br>");

        $query = "ALTER TABLE components ADD autocc varchar(100)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added autocc to components<br>");

        $query = "ALTER TABLE bugdesc ADD system int(1) DEFAULT '0'";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added system to bugdesc<br>");

        $query = "ALTER TABLE users ADD deleted int(1) DEFAULT '0'";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added deleted to users<br>");

        $query = "ALTER TABLE products ADD deleted int(1) DEFAULT '0'";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added deleted to products<br>");

        $query = "ALTER TABLE versions ADD deleted int(1) DEFAULT '0'";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added deleted to versions<br>");

        $query = "ALTER TABLE components ADD deleted int(1) DEFAULT '0'";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added deleted to components<br>");

        $query = "INSERT INTO config (id, name, value) VALUES (22,'mdaemonreplyto','')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added mdaemonreplyto to config<br>");

        $query = "ALTER TABLE bugs ADD fixedver varchar(8) DEFAULT NULL";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added fixedver to bugs</p>");

        $over = "021";
    }

    if ($over == "021")
    {
        // nothing to upgrade for 0.2.1 to 0.2.2
        $over = "022";
    }

    if ($over == "022")
    {
        print("<p>Updating database from 0.2.2 to 0.2.3...</p>");
        // upgrade from 0.2.2 to 0.2.3
        $query = "INSERT INTO status_d (id, name, s_def) VALUES (7,'TOVALIDATE','0')";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Added TOVALIDATE status<br>");

        $query = "INSERT INTO status_d (id, name, s_def) VALUES (8,'NEEDSWORK','0')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added NEEDSWORK status</p>");

        $over = "023";
    }

    if ($over == "023")
    {
        print("<p>Updating database from 0.2.3 to 0.2.4...</p>");
        // upgrade from 0.2.3 to 0.2.4
        $query = "INSERT INTO config (id, name, value) VALUES (23,'showrules','1')";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Added showrules to config<br>");

        $query = "INSERT INTO config (id, name, value) VALUES (24,'allowcompchange','0')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added allowcompchange to config<br>");

        $query = "INSERT INTO config (id, name, value) VALUES (25,'emailfooter','----<br>You are receiving this notice because you are the assignee, reporter, or a<br>watcher for this bug report.')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added emailfooter to config</p>");

        $over = "024";
    }

    if ($over == "024")
    {
        print("<p>Updating database from 0.2.4 to 0.2.5...</p>");
        // upgrade from 0.2.4 to 0.2.5
        $query = "INSERT INTO status_d (id, name, s_def) VALUES (9,'NEEDINFO','0')";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Added NEEDINFO status<br>");

        $query = "DELETE FROM config WHERE name = 'allowcompchange'";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Removed allowcompcange from config</p>");

        $over = "025";
    }

    if ($over == "025")
    {
        // nothing to upgrade for 0.2.5 to 0.2.6
        $over = "026";
    }

    if ($over == "026")
    {
        print("<p>Updating database from 0.2.6 to 0.3.0...</p>");
        // upgrade from 0.2.6 to 0.3.0

        $query = "INSERT INTO config (id, name, value) VALUES (24,'version','030')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Added version to config<br>");

        $query = "ALTER TABLE bugs CHANGE modified modified VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Changed structure of bugs.modified<br>");

        $query = "ALTER TABLE bugactivity CHANGE date date VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Changed structure of bugactivity.date<br>");

        $query = "ALTER TABLE bugdesc CHANGE date date VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Changed structure of bugdesc.date<br>");

        $query = "ALTER TABLE users CHANGE thison thison VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Changed structure of users.thison<br>");
        $query = "UPDATE users SET thison = ''";
        $result = $db->query($query);
        udberror($result, $query);
        print("Zeroed users.thison<br>");

        $query = "ALTER TABLE users CHANGE laston laston VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Changed structure of users.laston<br>");
        $query = "UPDATE users SET laston = ''";
        $result = $db->query($query);
        udberror($result, $query);
        print("Zeroed users.laston<br>");

        $query  = "CREATE TABLE bugdesc_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT did FROM bugdesc ORDER BY did DESC LIMIT 1");
        $query  = "INSERT INTO bugdesc_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Created table bugdesc_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE attachidx_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT atid FROM attachidx ORDER BY atid DESC LIMIT 1");
        $query  = "INSERT INTO attachidx_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table attachidx_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE bugactivity_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT aid FROM bugactivity ORDER BY aid DESC LIMIT 1");
        $query  = "INSERT INTO bugactivity_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table bugactivity_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE bugs_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT bid FROM bugs ORDER BY bid DESC LIMIT 1");
        $query  = "INSERT INTO bugs_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table bugs_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE components_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT cid FROM components ORDER BY cid DESC LIMIT 1");
        $query  = "INSERT INTO components_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table components_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE products_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT pid FROM products ORDER BY pid DESC LIMIT 1");
        $query  = "INSERT INTO products_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table products_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE users_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT uid FROM users ORDER BY uid DESC LIMIT 1");
        $query  = "INSERT INTO users_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table users_seq and set id to '$num'<br>");

        $query  = "CREATE TABLE versions_seq (id int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (id)) TYPE=MyISAM";
        $result = $db->query($query);
        udberror($result, $query);
        $num    = $db->getOne("SELECT vid FROM versions ORDER BY vid DESC LIMIT 1");
        $query  = "INSERT INTO versions_seq (id) VALUES ('$num')";
        $result = $db->query($query);
        udberror($result, $query);
        print("Created table versions_seq and set id to '$num'</p>");

        $query  = "ALTER TABLE bugactivity CHANGE user b_user INT(11)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Altered table bugactivity and changed user to b_user</p>");

        $query  = "ALTER TABLE bugactivity CHANGE date b_date VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Altered table bugactivity and changed date to b_date</p>");

        $query  = "ALTER TABLE bugdesc CHANGE user b_user INT(11)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Altered table bugdesc and changed user to b_user</p>");

        $query  = "ALTER TABLE bugdesc CHANGE date b_date VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Altered table bugdesc and changed date to b_date</p>");

        $query  = "ALTER TABLE attachidx CHANGE user a_user INT(11)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Altered table attachidx and changed user to a_user</p>");

        $query  = "ALTER TABLE attachidx CHANGE date a_date VARCHAR(14)";
        $result = $db->query($query);
        udberror($result, $query);
        print("Altered table attachidx and changed date to a_date</p>");

        $query = "DELETE FROM config WHERE name = 'bgcol'";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Removed bgcol from config</p>");

        $query = "DELETE FROM config WHERE name = 'textcol'";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Removed textcol from config</p>");

        $query = "DELETE FROM config WHERE name = 'linkcol'";
        $result = $db->query($query);
        udberror($result, $query);
        print("<p>Removed linkcol from config</p>");

        $over = "030";
    }

    if ($over = "030")
    {
        print("<p>Database upgrade complete.</p>");
        print("<p>Please delete this file from the system now.</p>");
        d_DrawFooter();
        exit;
    } else {
        print("<p>There was a problem with the database upgrade...  Your database may not be ready for this new version.</p>");
        d_DrawFooter();
        exit;
    }
}

print("<p>This script will upgrade the databases on your Anthill installation and provide you with any information you need to modify your config.inc.php file.</p>");
print("<p><b>Before executing this upgrade script, please make a backup of your database.</b></p>");
print("<p>If you are upgrading from a version prior to 0.3.0, you have to tell Anthill what version your are upgrading from.  You are upgrading <i>to</i> version <b>" . _VERSION . "</b>.  Be sure you select the correct version or you will have errors!");
print("<p>If you have made modifications to the database yourself, you may encounter some errors.  Likewise, if you are upgrading from a test, beta, or RC release you may also have some modifications already made to your database and you may encounter errors... the installer script will try to handle these errors intelligently.");
print("<p><font size=\"+1\"><b>You <i>have</i> done a backup of your database, right?  If not, please do so now!</b></font></p>");

// construct select list
$o      = NULL;
$select = NULL;
if ($config['version'] != "")
{
    $o = $config['version'];
    print("<p>Anthill thinks your existing version is '$o'...</p>");
}

$versions = array('020', '021', '022', '023', '024', '025', '026');
$vernames = array('0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6');

for ($i=0; $i<count($versions); $i++)
{
    $select .= "<option value=\"$versions[$i]\"";
    if ($versions[$i] == $o)
    {
        $select .= " SELECTED";
    }
    $select .= ">$vernames[$i]</option>\n";
}
    

$form = <<<EOF
    <form method="post" action="upgrade.php">
    <input type="hidden" name="go" value="doit">
    Select version to upgrade: <select name="over">
      $select
    </select>
    <input type="submit" value="Upgrade">
    </form>
EOF;

print($form);

  d_DrawFooter();
?>
